## qemu-linaro 1.2.0

=== Makefile ===
# Makefile for QEMU.

# Always point to the root of the build tree (needs GNU make).
BUILD_DIR=$(CURDIR)

# All following code might depend on configuration variables
ifneq ($(wildcard config-host.mak),)
# Put the all: rule here so that config-host.mak can contain dependencies.
all:
include config-host.mak
include $(SRC_PATH)/rules.mak
config-host.mak: $(SRC_PATH)/configure
	@echo $@ is out-of-date, running configure
	@sed -n "/.*Configured with/s/[^:]*: //p" $@ | sh
else
config-host.mak:
	@echo "Please call configure before running make!"
	@exit 1
endif

GENERATED_HEADERS = config-host.h trace.h qemu-options.def
ifeq ($(TRACE_BACKEND),dtrace)
GENERATED_HEADERS += trace-dtrace.h
endif
GENERATED_HEADERS += qmp-commands.h qapi-types.h qapi-visit.h
GENERATED_SOURCES += qmp-marshal.c qapi-types.c qapi-visit.c trace.c

# Don't try to regenerate Makefile or configure
# We don't generate any of them
Makefile: ;
configure: ;

.PHONY: all clean cscope distclean dvi html info install install-doc \
	pdf recurse-all speed test dist

$(call set-vpath, $(SRC_PATH))

LIBS+=-lz $(LIBS_TOOLS)

HELPERS-$(CONFIG_LINUX) = qemu-bridge-helper$(EXESUF)

ifdef BUILD_DOCS
DOCS=qemu-doc.html qemu-tech.html qemu.1 qemu-img.1 qemu-nbd.8 QMP/qmp-commands.txt
ifdef CONFIG_VIRTFS
DOCS+=fsdev/virtfs-proxy-helper.1
endif
else
DOCS=
endif

SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory) BUILD_DIR=$(BUILD_DIR)
SUBDIR_DEVICES_MAK=$(patsubst %, %/config-devices.mak, $(TARGET_DIRS))
SUBDIR_DEVICES_MAK_DEP=$(patsubst %, %/config-devices.mak.d, $(TARGET_DIRS))

config-all-devices.mak: $(SUBDIR_DEVICES_MAK)
	$(call quiet-command,cat $(SUBDIR_DEVICES_MAK) | grep =y | sort -u > $@,"  GEN   $@")

-include $(SUBDIR_DEVICES_MAK_DEP)

%/config-devices.mak: default-configs/%.mak
	$(call quiet-command,$(SHELL) $(SRC_PATH)/scripts/make_device_config.sh $@ $<, "  GEN   $@")
	@if test -f $@; then \
	  if cmp -s $@.old $@; then \
	    mv $@.tmp $@; \
	    cp -p $@ $@.old; \
	  else \
	    if test -f $@.old; then \
	      echo "WARNING: $@ (user modified) out of date.";\
	    else \
	      echo "WARNING: $@ out of date.";\
	    fi; \
	    echo "Run \"make defconfig\" to regenerate."; \
	    rm $@.tmp; \
	  fi; \
	 else \
	  mv $@.tmp $@; \
	  cp -p $@ $@.old; \
	 fi

defconfig:
	rm -f config-all-devices.mak $(SUBDIR_DEVICES_MAK)

-include config-all-devices.mak

all: $(DOCS) $(TOOLS) $(HELPERS-y) recurse-all

config-host.h: config-host.h-timestamp
config-host.h-timestamp: config-host.mak
qemu-options.def: $(SRC_PATH)/qemu-options.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@,"  GEN   $@")

SUBDIR_RULES=$(patsubst %,subdir-%, $(TARGET_DIRS))

subdir-%:
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $* V="$(V)" TARGET_DIR="$*/" all,)

ifneq ($(wildcard config-host.mak),)
include $(SRC_PATH)/Makefile.objs
endif

subdir-libcacard: $(oslib-obj-y) $(trace-obj-y) qemu-timer-common.o

$(filter %-softmmu,$(SUBDIR_RULES)): $(universal-obj-y) $(trace-obj-y) $(common-obj-y) $(extra-obj-y) subdir-libdis

$(filter %-user,$(SUBDIR_RULES)): $(universal-obj-y) $(trace-obj-y) subdir-libdis-user subdir-libuser

ROMSUBDIR_RULES=$(patsubst %,romsubdir-%, $(ROMS))
romsubdir-%:
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C pc-bios/$* V="$(V)" TARGET_DIR="$*/",)

ALL_SUBDIRS=$(TARGET_DIRS) $(patsubst %,pc-bios/%, $(ROMS))

recurse-all: $(SUBDIR_RULES) $(ROMSUBDIR_RULES)

audio/audio.o audio/fmodaudio.o: QEMU_CFLAGS += $(FMOD_CFLAGS)

QEMU_CFLAGS+=$(CURL_CFLAGS)

QEMU_CFLAGS += -I$(SRC_PATH)/include

ui/cocoa.o: ui/cocoa.m

ui/sdl.o audio/sdlaudio.o ui/sdl_zoom.o hw/baum.o: QEMU_CFLAGS += $(SDL_CFLAGS)

ui/vnc.o: QEMU_CFLAGS += $(VNC_TLS_CFLAGS)

bt-host.o: QEMU_CFLAGS += $(BLUEZ_CFLAGS)

version.o: $(SRC_PATH)/version.rc config-host.h
	$(call quiet-command,$(WINDRES) -I. -o $@ $<,"  RC    $(TARGET_DIR)$@")

version-obj-$(CONFIG_WIN32) += version.o
######################################################################
# Support building shared library libcacard

.PHONY: libcacard.la install-libcacard
ifeq ($(LIBTOOL),)
libcacard.la:
	@echo "libtool is missing, please install and rerun configure"; exit 1

install-libcacard:
	@echo "libtool is missing, please install and rerun configure"; exit 1
else
libcacard.la: $(oslib-obj-y) qemu-timer-common.o $(addsuffix .lo, $(basename $(trace-obj-y)))
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C libcacard V="$(V)" TARGET_DIR="$*/" libcacard.la,)

install-libcacard: libcacard.la
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C libcacard V="$(V)" TARGET_DIR="$*/" install-libcacard,)
endif

######################################################################

qemu-img.o: qemu-img-cmds.h

tools-obj-y = $(oslib-obj-y) $(trace-obj-y) qemu-tool.o qemu-timer.o \
	qemu-timer-common.o main-loop.o notify.o \
	iohandler.o cutils.o iov.o async.o
tools-obj-$(CONFIG_POSIX) += compatfd.o

qemu-img$(EXESUF): qemu-img.o $(tools-obj-y) $(block-obj-y)
qemu-nbd$(EXESUF): qemu-nbd.o $(tools-obj-y) $(block-obj-y)
qemu-io$(EXESUF): qemu-io.o cmd.o $(tools-obj-y) $(block-obj-y)

qemu-bridge-helper$(EXESUF): qemu-bridge-helper.o

vscclient$(EXESUF): $(libcacard-y) $(oslib-obj-y) $(trace-obj-y) $(tools-obj-y) qemu-timer-common.o libcacard/vscclient.o
	$(call quiet-command,$(CC) $(LDFLAGS) -o $@ $^ $(libcacard_libs) $(LIBS),"  LINK  $@")

fsdev/virtfs-proxy-helper$(EXESUF): fsdev/virtfs-proxy-helper.o fsdev/virtio-9p-marshal.o oslib-posix.o $(trace-obj-y)
fsdev/virtfs-proxy-helper$(EXESUF): LIBS += -lcap

qemu-img-cmds.h: $(SRC_PATH)/qemu-img-cmds.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@,"  GEN   $@")

qemu-ga$(EXESUF): LIBS = $(LIBS_QGA)
qemu-ga$(EXESUF): QEMU_CFLAGS += -I qga/qapi-generated

gen-out-type = $(subst .,-,$(suffix $@))

ifneq ($(wildcard config-host.mak),)
include $(SRC_PATH)/tests/Makefile
endif

qapi-py = $(SRC_PATH)/scripts/qapi.py $(SRC_PATH)/scripts/ordereddict.py

qga/qapi-generated/qga-qapi-types.c qga/qapi-generated/qga-qapi-types.h :\
$(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-types.py $(qapi-py)
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o qga/qapi-generated -p "qga-" < $<, "  GEN   $@")
qga/qapi-generated/qga-qapi-visit.c qga/qapi-generated/qga-qapi-visit.h :\
$(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-visit.py $(qapi-py)
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o qga/qapi-generated -p "qga-" < $<, "  GEN   $@")
qga/qapi-generated/qga-qmp-commands.h qga/qapi-generated/qga-qmp-marshal.c :\
$(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-commands.py $(qapi-py)
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -o qga/qapi-generated -p "qga-" < $<, "  GEN   $@")

qapi-types.c qapi-types.h :\
$(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-types.py $(qapi-py)
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o "." < $<, "  GEN   $@")
qapi-visit.c qapi-visit.h :\
$(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-visit.py $(qapi-py)
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o "."  < $<, "  GEN   $@")
qmp-commands.h qmp-marshal.c :\
$(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-commands.py $(qapi-py)
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -m -o "." < $<, "  GEN   $@")

QGALIB_GEN=$(addprefix qga/qapi-generated/, qga-qapi-types.h qga-qapi-visit.h qga-qmp-commands.h)
$(qga-obj-y) qemu-ga.o: $(QGALIB_GEN)

qemu-ga$(EXESUF): qemu-ga.o $(qga-obj-y) $(tools-obj-y) $(qapi-obj-y) $(qobject-obj-y) $(version-obj-y)

QEMULIBS=libhw32 libhw64 libuser libdis libdis-user

clean:
# avoid old build problems by removing potentially incorrect old files
	rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
	rm -f qemu-options.def
	find . -name '*.[od]' -exec rm -f {} +
	rm -f *.a *.lo $(TOOLS) $(HELPERS-y) qemu-ga TAGS cscope.* *.pod *~ */*~
	rm -Rf .libs
	rm -f qemu-img-cmds.h
	rm -f trace-dtrace.dtrace trace-dtrace.dtrace-timestamp
	@# May not be present in GENERATED_HEADERS
	rm -f trace-dtrace.h trace-dtrace.h-timestamp
	rm -f $(foreach f,$(GENERATED_HEADERS),$(f) $(f)-timestamp)
	rm -f $(foreach f,$(GENERATED_SOURCES),$(f) $(f)-timestamp)
	rm -rf qapi-generated
	rm -rf qga/qapi-generated
	$(MAKE) -C tests/tcg clean
	for d in $(ALL_SUBDIRS) $(QEMULIBS) libcacard; do \
	if test -d $$d; then $(MAKE) -C $$d $@ || exit 1; fi; \
	rm -f $$d/qemu-options.def; \
        done

VERSION ?= $(shell cat VERSION)

dist: qemu-$(VERSION).tar.bz2

qemu-%.tar.bz2:
	$(SRC_PATH)/scripts/make-release "$(SRC_PATH)" "$(patsubst qemu-%.tar.bz2,%,$@)"

distclean: clean
	rm -f config-host.mak config-host.h* config-host.ld $(DOCS) qemu-options.texi qemu-img-cmds.texi qemu-monitor.texi
	rm -f config-all-devices.mak
	rm -f roms/seabios/config.mak roms/vgabios/config.mak
	rm -f qemu-doc.info qemu-doc.aux qemu-doc.cp qemu-doc.cps qemu-doc.dvi
	rm -f qemu-doc.fn qemu-doc.fns qemu-doc.info qemu-doc.ky qemu-doc.kys
	rm -f qemu-doc.log qemu-doc.pdf qemu-doc.pg qemu-doc.toc qemu-doc.tp
	rm -f qemu-doc.vr
	rm -f config.log
	rm -f linux-headers/asm
	rm -f qemu-tech.info qemu-tech.aux qemu-tech.cp qemu-tech.dvi qemu-tech.fn qemu-tech.info qemu-tech.ky qemu-tech.log qemu-tech.pdf qemu-tech.pg qemu-tech.toc qemu-tech.tp qemu-tech.vr
	for d in $(TARGET_DIRS) $(QEMULIBS); do \
	rm -rf $$d || exit 1 ; \
        done

KEYMAPS=da     en-gb  et  fr     fr-ch  is  lt  modifiers  no  pt-br  sv \
ar      de     en-us  fi  fr-be  hr     it  lv  nl         pl  ru     th \
common  de-ch  es     fo  fr-ca  hu     ja  mk  nl-be      pt  sl     tr \
bepo

ifdef INSTALL_BLOBS
BLOBS=bios.bin sgabios.bin vgabios.bin vgabios-cirrus.bin \
vgabios-stdvga.bin vgabios-vmware.bin vgabios-qxl.bin \
ppc_rom.bin openbios-sparc32 openbios-sparc64 openbios-ppc \
pxe-e1000.rom pxe-eepro100.rom pxe-ne2k_pci.rom \
pxe-pcnet.rom pxe-rtl8139.rom pxe-virtio.rom \
qemu-icon.bmp \
bamboo.dtb petalogix-s3adsp1800.dtb petalogix-ml605.dtb \
multiboot.bin linuxboot.bin kvmvapic.bin \
s390-zipl.rom \
spapr-rtas.bin slof.bin \
palcode-clipper
else
BLOBS=
endif

install-doc: $(DOCS)
	$(INSTALL_DIR) "$(DESTDIR)$(qemu_docdir)"
	$(INSTALL_DATA) qemu-doc.html  qemu-tech.html "$(DESTDIR)$(qemu_docdir)"
	$(INSTALL_DATA) QMP/qmp-commands.txt "$(DESTDIR)$(qemu_docdir)"
ifdef CONFIG_POSIX
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DATA) qemu.1 qemu-img.1 "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man8"
	$(INSTALL_DATA) qemu-nbd.8 "$(DESTDIR)$(mandir)/man8"
endif
ifdef CONFIG_VIRTFS
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DATA) fsdev/virtfs-proxy-helper.1 "$(DESTDIR)$(mandir)/man1"
endif

install-datadir:
	$(INSTALL_DIR) "$(DESTDIR)$(qemu_datadir)"

install-confdir:
	$(INSTALL_DIR) "$(DESTDIR)$(qemu_confdir)"

install-sysconfig: install-datadir install-confdir
	$(INSTALL_DATA) $(SRC_PATH)/sysconfigs/target/target-x86_64.conf "$(DESTDIR)$(qemu_confdir)"
	$(INSTALL_DATA) $(SRC_PATH)/sysconfigs/target/cpus-x86_64.conf "$(DESTDIR)$(qemu_datadir)"

install: all $(if $(BUILD_DOCS),install-doc) install-sysconfig install-datadir
	$(INSTALL_DIR) "$(DESTDIR)$(bindir)"
ifneq ($(TOOLS),)
	$(INSTALL_PROG) $(STRIP_OPT) $(TOOLS) "$(DESTDIR)$(bindir)"
endif
ifneq ($(HELPERS-y),)
	$(INSTALL_DIR) "$(DESTDIR)$(libexecdir)"
	$(INSTALL_PROG) $(STRIP_OPT) $(HELPERS-y) "$(DESTDIR)$(libexecdir)"
endif
ifneq ($(BLOBS),)
	set -e; for x in $(BLOBS); do \
		[ -e "$(SRC_PATH)/pc-bios/$$x" ] || continue; \
		$(INSTALL_DATA) $(SRC_PATH)/pc-bios/$$x "$(DESTDIR)$(qemu_datadir)"; \
	done
endif
	$(INSTALL_DIR) "$(DESTDIR)$(qemu_datadir)/keymaps"
	set -e; for x in $(KEYMAPS); do \
		$(INSTALL_DATA) $(SRC_PATH)/pc-bios/keymaps/$$x "$(DESTDIR)$(qemu_datadir)/keymaps"; \
	done
	for d in $(TARGET_DIRS); do \
	$(MAKE) -C $$d $@ || exit 1 ; \
        done

# various test targets
test speed: all
	$(MAKE) -C tests/tcg $@

## qemu-linaro 1.2.0-2012.09

=== debian/changelog ===
qemu-linaro (1.2.0-2012.09-0ubuntu1) quantal; urgency=low

  [ Fathi Boudra ]
  * FFe for new upstream version (LP: #1053212)
    - Compatibility with ARM realview kernels > 3.0 with VFP (LP: #1052380)
  * Also pass -fno-var-tracking on armhf

  [ Ricardo Salveti de Araujo ]
  * Bump to standards 3.9.3

 -- Ricardo Salveti de Araujo <ricardo.salveti@linaro.org>  Thu, 20 Sep 2012 15:52:57 -0300

qemu-linaro (1.1.50-2012.08-0ubuntu1) quantal; urgency=low

  * New upstream release.
    - support emulated systems with more than 2G of memory. (LP: #1030588)
  * Drop powerpc-missing-include.patch - merged upstream.
  * Update debian/control: 
    - drop perl build dependency.
    - add libfdt-dev build dependency.
  * Update debian/qemu-keymaps.install file.
  * Update debian/rules:
    - update QEMU_CPU for ARM architecture: armv4l -> armv7l.
    - update conf_audio_drv: default to PulseAudio since PA is the default on
      Ubuntu.
    - enable KVM on ARM architecture.
    - enable flat device tree support (--enable-fdt). (LP: #1030594)

 -- Fathi Boudra <fabo@debian.org>  Tue, 21 Aug 2012 08:47:11 +0300

qemu-linaro (1.0.50-2012.03-0ubuntu3) quantal; urgency=low

  * debian/control:
    - Build-depend on libvdeplug-dev instead of libvdeplug2-dev

 -- Jeremy Bicha <jbicha@ubuntu.com>  Mon, 04 Jun 2012 11:13:41 -0400

=== debian/control ===
Source: qemu-linaro
Section: misc
Priority: optional
DM-Upload-Allowed: yes
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Aurelien Jarno <aurel32@debian.org>,
           Riku Voipio <riku.voipio@iki.fi>,
           Vagrant Cascadian <vagrant@debian.org>
Build-Depends: debhelper (>= 9.0.0),
               libasound2-dev [!kfreebsd-any],
               libbluetooth-dev [!kfreebsd-any],
               libbrlapi-dev,
               libcurl4-gnutls-dev,
               libfdt-dev,
               libgnutls-dev,
               libncurses5-dev,
               libpulse-dev,
               libsasl2-dev,
               libsdl1.2-dev (>> 1.2.1),
               libspice-protocol-dev [amd64],
               libspice-server-dev [amd64],
               libvdeplug-dev [!kfreebsd-any],
               libx11-dev,
               texinfo,
               uuid-dev,
               zlib1g-dev
Build-Conflicts: oss4-dev
Standards-Version: 3.9.3
Homepage: https://launchpad.net/qemu-linaro/
Vcs-Bzr: lp:ubuntu/qemu-linaro

Package: qemu-keymaps
Architecture: all
Depends: ${misc:Depends}
Breaks: qemu (<< 0.11.0-2), qemu-system (<< 0.12.4+dfsg-4)
Replaces: qemu (<< 0.11.0-2), qemu-system (<< 0.12.4+dfsg-4)
Description: QEMU keyboard maps
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides keyboard maps to be used by the qemu-system
 package or QEMU derivatives.

Package: qemu-system
Architecture: amd64 arm armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc ppc64 sparc sparc64
Depends: qemu-common,
         qemu-keymaps (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: qemu-kvm, vde2
Breaks: qemu (<< 0.11.0-2), qemu-kvm-extras (<< 0.13.50-2011.02-0~rc1-0ubuntu1)
Replaces: qemu (<< 0.11.0-2),
          qemu-kvm-extras (<< 0.13.50-2011.02-0~rc1-0ubuntu1)
Suggests: samba
Description: QEMU full system emulation binaries
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the full system emulation binaries for targets other
 than x86 and x86-64.  In this mode QEMU emulates a full system, including a
 processor and various peripherals.  It enables easier testing and debugging
 of system code.  It can also be used to provide virtual hosting of several
 virtual machines on a single server.

Package: qemu-user
Architecture: amd64 arm armel armhf hppa i386 ia64 mips mipsel powerpc ppc64 sparc sparc64
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: qemu (<< 0.11.0-2), qemu-kvm-extras (<< 0.13.50-2011.02-0~rc1-0ubuntu1)
Replaces: qemu (<< 0.11.0-2),
          qemu-kvm (<< 0.13.0+noroms-0ubuntu13),
          qemu-kvm-extras (<< 0.13.50-2011.02-0~rc1-0ubuntu1)
Description: QEMU user mode emulation binaries
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the user mode emulation binaries for targets other
 than x86 and x86-64.  In this mode QEMU can launch Linux processes compiled
 for one CPU on another CPU.

Package: qemu-user-static
Architecture: amd64 arm armel armhf hppa i386 ia64 mips mipsel powerpc ppc64 sparc sparc64
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: binfmt-support, debootstrap
Breaks: qemu-kvm-extras-static (<< 0.13.50-2011.02-0~rc1-0ubuntu1)
Replaces: qemu-kvm-extras-static (<< 0.13.50-2011.02-0~rc1-0ubuntu1)
Suggests: sudo
Description: QEMU user mode emulation binaries (static version)
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the user mode emulation binaries, built
 statically. In this mode QEMU can launch Linux processes compiled for
 one CPU on another CPU.

Package: qemu-kvm-extras
Architecture: all
Depends: qemu-system, qemu-user
Description: QEMU system and user mode emulation (transitional package)
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This is a transitional package depending on the system and user mode
 emulation binaries.  You can remove it once the upgrade is complete and
 nothing depends on it.

Package: qemu-kvm-extras-static
Architecture: all
Depends: qemu-user-static
Description: QEMU static user mode emulation binaries (transitional package)
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This is a transitional package depending on the static user mode emulation
 binaries.  You can remove it once the upgrade is complete and nothing
 depends on it.

Package: qemu-kvm-spice
Architecture: amd64
Depends: libspice-server1, qemu-kvm, ${misc:Depends}, ${shlibs:Depends}
Description: Full virtualization on amd64 hardware
 This adds versions of qemu-kvm which can use SPICE, called qemu-kvm-spice.

=== debian/rules ===
#!/usr/bin/make -f

deb_source := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
deb_version := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
upstream_version := $(shell echo '$(deb_version)' | sed 's/.*://; s/-[^-]*$$//')
git_rev := $(shell echo '$(upstream_version)' | sed 's/.*+//')

DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS = $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH_CPU = $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_HOST_GNU_CPU = $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_GNU_TYPE = $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE = $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_ARCH = $(shell dpkg-architecture -qDEB_BUILD_ARCH)

QEMU_CPU = $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
ifeq ($(QEMU_CPU),powerpc)
  QEMU_CPU = ppc
endif
ifneq (,$(filter $(DEB_HOST_ARCH),armel armhf))
  QEMU_CPU = armv7l
endif

ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  conf_arch += --cross-prefix=$(DEB_HOST_GNU_TYPE)- --cpu=$(QEMU_CPU)
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
# Note: We differ from Debian here by favoring the pulseaudio driver, since that's default in Ubuntu.
#       Users override this when calling qemu by exporting the environment variable QEMU_AUDIO_DRV.
       conf_audio_drv += --audio-drv-list=pa,alsa,sdl,oss
endif
ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
       conf_audio_drv += --audio-drv-list=oss,sdl,pa
endif
# KVM on PowerPC needs at least 2.6.33 kernel headers
ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
       conf_arch += --disable-kvm
endif

ifeq ($(DEB_HOST_ARCH_CPU),arm)
       conf_arch += --enable-kvm
endif


# binfmt support
ALL_BINFMT_TARGETS=alpha arm armeb cris i386 m68k microblaze mips mipsel ppc ppc64 ppc64abi32 sh4 sh4eb sparc sparc32plus sparc64 x86_64
ifeq ($(DEB_HOST_ARCH),amd64)
BINFMT_TARGETS=$(filter-out i386 x86_64, $(ALL_BINFMT_TARGETS))
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel armhf))
BINFMT_TARGETS=$(filter-out arm, $(ALL_BINFMT_TARGETS))
endif
ifeq ($(DEB_HOST_ARCH),i386)
BINFMT_TARGETS=$(filter-out i386, $(ALL_BINFMT_TARGETS))
endif
ifeq ($(DEB_HOST_ARCH),powerpc)
BINFMT_TARGETS=$(filter-out ppc, $(ALL_BINFMT_TARGETS))
endif
ifeq ($(DEB_HOST_ARCH),ppc64)
BINFMT_TARGETS=$(filter-out ppc ppc64 ppc64abi32 , $(ALL_BINFMT_TARGETS))
endif
ifeq ($(DEB_HOST_ARCH),sparc)
BINFMT_TARGETS=$(filter-out sparc sparc32plus sparc64, $(ALL_BINFMT_TARGETS))
endif
ifeq ($(DEB_HOST_ARCH),sparc64)
BINFMT_TARGETS=$(filter-out sparc sparc32plus sparc64, $(ALL_BINFMT_TARGETS))
endif
ifeq ($(BINFMT_TARGETS),)
BINFMT_TARGETS=$(ALL_BINFMT_TARGETS)
endif

# namespace to use for data files
NAMESPACE := linaro

# basedir in which to install BIOSes and keymaps below prefix
DATASUBDIR := share/qemu-$(NAMESPACE)
DATADIR := /usr/$(DATASUBDIR)
# XXX doesn't work because it's #defined in the source should send an upstream
# patch to allow ./configuring that
#CFLAGS += -DSHARE_SUFFIX="$(DATASUBDIR)"

# Workaround for var tracking blowing up the memory requirements more than
# tenfold on armel; we'll keep -g enabled but disable this particular feature
ifneq (,$(findstring $(DEB_HOST_ARCH), armel armhf))
CFLAGS += -fno-var-tracking
endif

# XXX for some reason, --remote doesn't work with gitorious so this needs to be
# run from a local checkout
# --remote=git://gitorious.org/qemu-maemo/qemu-maemo.git
get-orig-source:
	git archive \
	    --format=tar \
	    --prefix=$(deb_source)-$(upstream_version)/ \
	    $(git_rev) \
	    | gzip >$(deb_source)_$(upstream_version).orig.tar.gz

override_dh_auto_configure:
	# system build
	mkdir -p $(CURDIR)/system-build
	cd $(CURDIR)/system-build && \
		../configure \
		    --with-pkgversion="Debian $(deb_version)" \
		    --extra-cflags="$(CFLAGS)" \
		    --extra-ldflags="$(LDFLAGS)" \
		    --prefix=/usr \
		    --datadir=$(DATADIR) \
		    --interp-prefix=/etc/qemu-binfmt/%M \
		    --disable-blobs \
		    --disable-strip \
		    --disable-linux-user \
		    --disable-bsd-user \
		    --disable-spice \
		    --enable-fdt \
		    $(conf_arch) $(conf_audio_drv)

ifeq ($(DEB_HOST_ARCH_OS),linux)
	# user build
	mkdir -p $(CURDIR)/user-build
	cd $(CURDIR)/user-build && \
		../configure \
		    --with-pkgversion="Debian $(deb_version)" \
		    --extra-cflags="$(CFLAGS)" \
		    --extra-ldflags="$(LDFLAGS)" \
		    --prefix=/usr \
		    --datadir=$(DATADIR) \
		    --interp-prefix=/etc/qemu-binfmt/%M \
		    --disable-blobs \
		    --disable-strip \
		    --disable-system \
		    --enable-uname-release=2.6.32 \
		    $(conf_arch)

	# static user build
	mkdir -p $(CURDIR)/user-static-build
	cd $(CURDIR)/user-static-build && \
		../configure \
		    --with-pkgversion="Debian $(deb_version)" \
		    --extra-cflags="$(CFLAGS)" \
		    --extra-ldflags="$(LDFLAGS)" \
		    --prefix=/usr \
		    --datadir=$(DATADIR) \
		    --interp-prefix=/etc/qemu-binfmt/%M \
		    --disable-blobs \
		    --disable-strip \
		    --disable-system \
		    --static \
		    --enable-uname-release=2.6.32 \
		    $(conf_arch)

ifeq ($(DEB_HOST_ARCH),amd64)
	# spice build
	mkdir -p $(CURDIR)/spice-build
	cd $(CURDIR)/spice-build && \
		../configure \
		    --with-pkgversion="Debian $(deb_version)" \
		    --extra-cflags="$(CFLAGS)" \
		    --extra-ldflags="$(LDFLAGS)" \
		    --prefix=/usr \
		    --interp-prefix=/etc/qemu-binfmt/%M \
		    --disable-blobs \
		    --disable-strip \
		    --disable-system \
		    --target-list="x86_64-softmmu i386-softmmu x86_64-linux-user i386-linux-user" \
		    --enable-spice \
		    $(conf_arch)
endif
endif

override_dh_auto_build:
	# system build
	dh_auto_build -B system-build --parallel
ifeq ($(DEB_HOST_ARCH_OS),linux)
	# user build
	dh_auto_build -B user-build --parallel

	# static user build
	dh_auto_build -B user-static-build --parallel

ifeq ($(DEB_HOST_ARCH),amd64)
	# spice build
	dh_auto_build -B spice-build --parallel
endif
endif

override_dh_auto_install:
ifeq ($(DEB_HOST_ARCH_OS),linux)
	dh_auto_install -B user-static-build --destdir=$(CURDIR)/debian/tmp
	for script in prerm postinst; do \
		sed -e 's/^BINFMT_TARGETS=.*/BINFMT_TARGETS=\"$(BINFMT_TARGETS)\"/g' \
                $(CURDIR)/debian/qemu-user-static.$$script.in \
		> $(CURDIR)/debian/qemu-user-static.$$script; \
	done
	for target in $(CURDIR)/debian/tmp/usr/bin/qemu-*; do \
		install -m 755 $$target $(CURDIR)/debian/tmp/usr/bin/$$(basename $$target)-static; \
	done
	dh_auto_install -B user-build --destdir=$(CURDIR)/debian/tmp
	for target in $(BINFMT_TARGETS) ; do \
		install -m 644 $(CURDIR)/debian/binfmts/qemu-$$target \
			$(CURDIR)/debian/qemu-user-static/usr/share/binfmts ; \
	done
	f=debian/qemu-user-static.sysctl; [ -f debian/qemu-user-static.sysctl.$(DEB_BUILD_ARCH) ] && f=debian/qemu-user-static.sysctl.$(DEB_BUILD_ARCH); cp $$f debian/qemu-user-static/etc/sysctl.d/30-qemu-user-static.conf
ifeq ($(DEB_HOST_ARCH),amd64)
	dh_auto_install -B spice-build --destdir=$(CURDIR)/debian/spice-tmp
	for target in qemu-i386 qemu-x86_64 qemu-system-x86_64; do \
		mv $(CURDIR)/debian/spice-tmp/usr/bin/$$target \
			$(CURDIR)/debian/spice-tmp/usr/bin/$$target-spice; \
	done
	mv $(CURDIR)/debian/spice-tmp/usr/bin/qemu-system-i386 \
	   $(CURDIR)/debian/spice-tmp/usr/bin/qemu-spice
endif
endif
	dh_auto_install -B system-build --destdir=$(CURDIR)/debian/tmp
	mv $(CURDIR)/debian/tmp/usr/share/man/man1/qemu.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/qemu-system.1

override_dh_install:
ifeq ($(DEB_HOST_ARCH),amd64)
	dh_install -pqemu-kvm-spice --sourcedir=$(CURDIR)/debian/spice-tmp
endif
	dh_install -Nqemu-kvm-spice

override_dh_auto_clean:
	rm -rf user-static-build user-build system-build spice-build

override_dh_auto_test:
	# tests are broken ATM

%:
	dh $@

.PHONY: get-orig-source

=== debian/watch ===
version=3
opts=uversionmangle=s/-rc/~rc/,dversionmangle=s/\+dfsg\d*$// \
https://launchpad.net/qemu-linaro/+download https://launchpad.net/qemu-linaro/.*/.*/\+download/qemu-linaro-(.+).tar.gz
